node['filesystem']['config'].each do |device, values|
  next if device == 'defaults'
  options = Mash.new

  if !node['filesystem']['config']['defaults'].nil? && !node['filesystem']['config']['defaults'][values['type']].nil?
    options = Chef::Mixin::DeepMerge.merge(values['options'], node['filesystem']['config']['defaults'][values['type']])
  else
    options = values['options']
  end

  detect_key = ''
  detect_val = ''
  optionsstr = options.map do |k, v|
    case v
    when TrueClass, FalseClass
      if k.length > 1
        "--#{k}"
      else
        "-#{k}"
      end
    when Array
      if k.length > 1
        "--#{k} #{v.join(',')}"
      else
        "-#{k} #{v.join(',')}"
      end
    else
      if k == 'L'
        detect_key = 'by-label'
        detect_val = v
      end
      if k.length > 1
        "--#{k} #{v}"
      else
        "-#{k} #{v}"
      end
    end
  end.join(' ')

  cmd = ''
  case values['type']
  when 'ext2','ext3','ext4'
    cmd = 'tune2fs'
  end

  case detect_key
  when 'by-label'
    detect_cmd = "blkid -c /dev/null -L #{detect_val}"
  end

  execute "sleep for #{device}" do
    command "sleep 5s"
    action :nothing
  end

  execute "#{cmd} #{optionsstr} #{device}" do
    not_if detect_cmd
    notifies :run, "execute[sleep for #{device}]", :immediately
  end

end
